CREATE OR REPLACE PROCEDURE GERA_PEDIDO_POR_REQUISICAO
(P_CDFILIAL VARCHAR2, 
 P_DATAINI DATE,
 P_DATAFIN DATE,
 P_NRLISTAREQUIPEDIDO VARCHAR2,
 P_QUEBRATURNO VARCHAR2,
 P_CDOPERADOR VARCHAR2,
 P_CDFILIPROC VARCHAR2,
 P_CDFILIALPADRAO VARCHAR2,
 P_CDSERVPADRAO VARCHAR2
)
AS
   V_CONTADOR VARCHAR2(100); -- Contador da novocodigo
   V_SEQUENCIAL VARCHAR2(20); -- Sequencial da novocodigo
   V_SEQREQUIPEDIDO VARCHAR2(10); -- Sequencial da REQUIPEDIDO

   V_CDPRODCOMPRA VARCHAR2(10); -- Produto de compra
   V_CDARVPRODCOMPRA VARCHAR2(20); -- Cd. rvore do produto de compra
   V_VRFATOCONV FLOAT; -- Fator de converso do produto de compra
   V_VRARREDCMP FLOAT; -- Arredondamento de compras
   V_CDMARCA VARCHAR2(5); -- Marca do produto de compra
   V_QUANTIDADE FLOAT; -- Quantidade do produto de compra

   V_NRPEDEXOL VARCHAR2(10); -- Nmero do pedido
   V_CDEMPRESA VARCHAR2(2); -- Empresa
   V_IDTIPEMIT VARCHAR2(1); -- Tipo de Emisso

   V_COUNT FLOAT; --Contador genrico

   V_NRLIMISEGU NUMBER; -- Limite de segurana do produto requisitado (estoque)
   V_DTPRODUTO DATE; -- Data calculada de entrega do produto requisitado

   V_LISTASERV VARCHAR2(4000);
   V_LISTAFILIAL VARCHAR2(4000);
BEGIN
   --- Monta a lista de servios, caso tenha que consolidar por servio (PODERIA SER UTILIZADO A FUNCAO LISTAGG)
   V_LISTASERV := '';
   IF NOT (P_CDSERVPADRAO IS NULL) THEN
      FOR C_LISTASERV IN (
         SELECT DISTINCT R.CDSERVFILI
         FROM REQUIPEDIDO R INNER JOIN LISTA L
                               ON L.NRLISTA = P_NRLISTAREQUIPEDIDO AND
                                  R.NRREQUIPEDIDO = TO_NUMBER(L.CDLISTA)
                            LEFT JOIN PEDIDOEXOL P
                               ON P.CDFILDEST = R.CDFILDEST AND
                                  P.CDFILLANC = R.CDFILLANC AND
                                  P.NRPEDEXOL = R.NRPEDEXOL
         WHERE P.NRPEDEXOL IS NULL
           AND R.DTREQUIPEDIDO BETWEEN P_DATAINI AND P_DATAFIN
      ) LOOP
         V_LISTASERV := V_LISTASERV || '_' || C_LISTASERV.CDSERVFILI;
      END LOOP;
      V_LISTASERV := V_LISTASERV || '_';
   END IF;

   V_LISTAFILIAL := '';
   IF NOT (P_CDFILIALPADRAO IS NULL) THEN
      FOR C_LISTAFILIAL IN (
         SELECT DISTINCT R.CDFILIAL
         FROM REQUIPEDIDO R INNER JOIN LISTA L
                               ON L.NRLISTA = P_NRLISTAREQUIPEDIDO AND
                                  R.NRREQUIPEDIDO = TO_NUMBER(L.CDLISTA)
                            LEFT JOIN PEDIDOEXOL P
                               ON P.CDFILDEST = R.CDFILDEST AND
                                  P.CDFILLANC = R.CDFILLANC AND
                                  P.NRPEDEXOL = R.NRPEDEXOL
         WHERE P.NRPEDEXOL IS NULL
           AND R.DTREQUIPEDIDO BETWEEN P_DATAINI AND P_DATAFIN
      ) LOOP
         V_LISTAFILIAL := V_LISTAFILIAL || '_' || C_LISTAFILIAL.CDFILIAL;
      END LOOP;
      V_LISTAFILIAL := V_LISTAFILIAL || '_';
   END IF;

   -- Percorre os agrupamentos que geraro pedidos
   FOR C_REQUISICOES IN (
      SELECT DISTINCT
             CASE WHEN P_CDFILIALPADRAO IS NULL THEN R.CDFILIAL ELSE P_CDFILIALPADRAO END AS CDFILIAL,
             CASE WHEN P_CDSERVPADRAO IS NULL THEN R.CDSERVFILI ELSE P_CDSERVPADRAO END AS CDSERVFILI,
             R.DTREQUIPEDIDO, R.CDGRUPPROD, R.CDSUBGRPROD, R.CDFILIOPELOG,
             CASE WHEN P_QUEBRATURNO = 'S' THEN R.CDTURNO ELSE NULL END AS CDTURNO
      FROM REQUIPEDIDO R INNER JOIN LISTA L
                            ON L.NRLISTA = P_NRLISTAREQUIPEDIDO AND
                               R.NRREQUIPEDIDO = TO_NUMBER(L.CDLISTA)
                         LEFT JOIN PEDIDOEXOL P
                            ON P.CDFILDEST = R.CDFILDEST AND
                               P.CDFILLANC = R.CDFILLANC AND
                               P.NRPEDEXOL = R.NRPEDEXOL
      WHERE P.NRPEDEXOL IS NULL
         AND R.DTREQUIPEDIDO BETWEEN P_DATAINI AND P_DATAFIN
      ORDER BY R.DTREQUIPEDIDO,
               CASE WHEN P_CDFILIALPADRAO IS NULL THEN R.CDFILIAL ELSE P_CDFILIALPADRAO END,
               CASE WHEN P_QUEBRATURNO = 'S' THEN R.CDTURNO ELSE NULL END,
               R.CDGRUPPROD,
               R.CDSUBGRPROD,
               R.CDFILIOPELOG
   ) LOOP
      -- Sequencial de requisio por filial, servio e data
      V_CONTADOR := 'SEQREQUIPEDIDO' || C_REQUISICOES.CDFILIAL || C_REQUISICOES.CDSERVFILI || TO_CHAR(C_REQUISICOES.DTREQUIPEDIDO, 'YYYYMMDD');
      NOVO_CODIGO(V_CONTADOR, V_SEQUENCIAL);
      V_SEQREQUIPEDIDO := SUBSTR(V_SEQUENCIAL, -10);
      ------------------------------------------------------------------------------------
      -- Inclui o pedido
      ------------------------------------------------------------------------------------
      NOVO_CODIGO('PEDIDOEXOL'||C_REQUISICOES.CDFILIAL || P_CDFILIPROC, V_SEQUENCIAL);
      V_NRPEDEXOL := SUBSTR(V_SEQUENCIAL, -10);

      -- Empresa e tipo de emisso
      SELECT
         MAX(PARCMPSUP.IDTIPEMITGER),
         MAX(PARCMPSUP.CDEMPRESA)
      INTO
         V_IDTIPEMIT,
         V_CDEMPRESA
      FROM
         PARCMPSUP
      WHERE
         (PARCMPSUP.CDFILIAL = C_REQUISICOES.CDFILIAL);

      IF (V_IDTIPEMIT = '1') OR (V_IDTIPEMIT = '3') THEN
         SELECT
            MAX(FILIAL.CDEMPRESA)
         INTO
            V_CDEMPRESA
         FROM
            FILIAL
         WHERE
            (CDFILIAL = C_REQUISICOES.CDFILIAL);
      END IF;

      INSERT INTO PEDIDOEXOL (CDFILDEST, CDFILLANC, NRPEDEXOL,
                              DTPEDEXOL, IDEMITEXOL, CDEMPRESA,
                              CDFILIOPELOG, IDTIPOEXOL,
                              NRREQUISICAOPLA, DTPREVRETIPLA,
                              CDFILIREQUISPLA, CDSERVICOPLA,
                              CDTURNOPLA)
      VALUES (C_REQUISICOES.CDFILIAL, P_CDFILIPROC, V_NRPEDEXOL,
              TO_DATE(SYSDATE), V_IDTIPEMIT, V_CDEMPRESA,
              C_REQUISICOES.CDFILIOPELOG, 'A',
              V_SEQREQUIPEDIDO, C_REQUISICOES.DTREQUIPEDIDO,
              C_REQUISICOES.CDFILIAL, C_REQUISICOES.CDSERVFILI,
              C_REQUISICOES.CDTURNO);

      ------------------------------------------------------------------------------------
      ------------------------------------------------------------------------------------

      -- Percorre os produtos da(s) requisio(es)
      FOR C_PRODUTOS IN
      (
      SELECT P.CDPRODUTO, PT.CDARVPROD, SUM(CASE WHEN T.CDTURNO = '1' THEN NVL(P.QTPRERETT1, 0.00)
                                    WHEN T.CDTURNO = '2' THEN NVL(P.QTPRERETT2, 0.00)
                                    WHEN T.CDTURNO = '3' THEN NVL(P.QTPRERETT3, 0.00)
                                    WHEN T.CDTURNO = '4' THEN NVL(P.QTPRERETT4, 0.00)
                                    ELSE 0.00
                               END) AS QUANTIDADE
           FROM PREVRETI P
                INNER JOIN PRODUTO PT ON P.CDPRODUTO = PT.CDPRODUTO
                INNER JOIN TURNOSERV T ON T.CDFILIAL = P.CDFILIAL AND
                                          T.CDSERVFILI = P.CDSERVFILI AND
                                          (T.CDTURNO = C_REQUISICOES.CDTURNO OR C_REQUISICOES.CDTURNO IS NULl)
          WHERE /*P.CDFILIAL = C_REQUISICOES.CDFILIAL AND*/
                ((P.CDFILIAL = C_REQUISICOES.CDFILIAL AND P_CDFILIALPADRAO IS NULL) OR ((P_CDFILIALPADRAO IS NOT NULL) AND INSTR(V_LISTAFILIAL, P.CDFILIAL)>0))
            AND ((P.CDSERVFILI = C_REQUISICOES.CDSERVFILI AND P_CDSERVPADRAO IS NULL) OR ((P_CDSERVPADRAO IS NOT NULL) AND INSTR(V_LISTASERV, P.CDSERVFILI)>0))
            AND P.DTPREVRETI = C_REQUISICOES.DTREQUIPEDIDO
            AND P.CDFILIOPELOG = C_REQUISICOES.CDFILIOPELOG
            AND (P.CDGRUPPROD = C_REQUISICOES.CDGRUPPROD OR C_REQUISICOES.CDGRUPPROD IS NULL)
            AND (P.CDSUBGRPROD = C_REQUISICOES.CDSUBGRPROD OR C_REQUISICOES.CDSUBGRPROD IS NULL)
            --Garante que, quando no quebrar por turno, apenas produtos de requisies selecionadas sejam gerados
            AND EXISTS (SELECT 1
                          FROM REQUIPEDIDO R
                               INNER JOIN LISTA L ON L.NRLISTA = P_NRLISTAREQUIPEDIDO AND
                                R.NRREQUIPEDIDO = TO_NUMBER(L.CDLISTA)
                         WHERE CDFILIAL = P.CDFILIAL
                           AND CDSERVFILI = P.CDSERVFILI
                           AND DTREQUIPEDIDO = P.DTPREVRETI
                           AND CDTURNO = T.CDTURNO
                           AND CDGRUPPROD = P.CDGRUPPROD
                           AND CDSUBGRPROD = P.CDSUBGRPROD
                           AND CDFILIOPELOG = P.CDFILIOPELOG)
          GROUP BY P.CDPRODUTO, PT.CDARVPROD
      ) LOOP
         /* Produto de compra para abastecimento da OL na filial (Embalagem)*/
           SELECT MAX(CDPRODUTO), MAX(CDARVPROD), MAX(VRFATOCONV), MAX(VRARREDCMP)
             INTO V_CDPRODCOMPRA, V_CDARVPRODCOMPRA, V_VRFATOCONV, V_VRARREDCMP
             FROM PRODUTO
            WHERE CDPRODUTO =
           (SELECT MIN(PT.CDPRODUTO)
              FROM PARAMPRODSUP P
                   INNER JOIN PRODUTO PT ON PT.CDPRODUTO = P.CDPRODUTO,
                    -- Menor fator de correo
                    (SELECT MAX(Q.QUANTIDADE) QUANTIDADE, MIN(PT.VRFATOCONV) VRFATOCONV
                      FROM PARAMPRODSUP P
                           INNER JOIN PRODUTO PT ON PT.CDPRODUTO = P.CDPRODUTO,
                           -- Quantidade de produtos
                           (SELECT COUNT(1) QUANTIDADE
                              FROM PARAMPRODSUP P
                                   INNER JOIN PRODUTO PT ON PT.CDPRODUTO = P.CDPRODUTO
                             WHERE P.CDFILIAL = C_REQUISICOES.CDFILIAL
                               AND P.CDFILIOPELOG = C_REQUISICOES.CDFILIOPELOG
                               AND PT.CDPRODESTO = C_PRODUTOS.CDPRODUTO
                               AND PT.IDPRCMPATIVO = 'S') Q
                     WHERE P.CDFILIAL = C_REQUISICOES.CDFILIAL
                       AND P.CDFILIOPELOG = C_REQUISICOES.CDFILIOPELOG
                       AND PT.CDPRODESTO = C_PRODUTOS.CDPRODUTO
                       -- Utiliza o produto de estoque apenas se ele for o nico associado  O.L.
                       AND ( ( Q.QUANTIDADE > 1 AND PT.CDPRODESTO <> PT.CDPRODUTO) OR (Q.QUANTIDADE <= 1) )
                       AND PT.IDPRCMPATIVO = 'S') M
             WHERE P.CDFILIAL = C_REQUISICOES.CDFILIAL
               AND P.CDFILIOPELOG = C_REQUISICOES.CDFILIOPELOG
               AND PT.CDPRODESTO = C_PRODUTOS.CDPRODUTO
               -- Utiliza o produto de estoque apenas se ele for o nico associado  O.L.s
               AND ( ( M.QUANTIDADE > 1 AND PT.CDPRODESTO <> PT.CDPRODUTO) OR (M.QUANTIDADE <= 1) )
               AND PT.IDPRCMPATIVO = 'S'
               AND PT.VRFATOCONV =  M.VRFATOCONV);

         IF V_CDPRODCOMPRA IS NOT NULL AND V_VRFATOCONV IS NOT NULL THEN

            -- Ativa o produto de compra na filial de destino se ainda no est
            V_COUNT := 0;
            SELECT COUNT(1)
              INTO V_COUNT
              FROM PRODFILI
             WHERE PRODFILI.CDPRODUTO = V_CDPRODCOMPRA
               AND PRODFILI.CDFILIAL = C_REQUISICOES.CDFILIAL;
            IF V_COUNT > 0 THEN
               UPDATE PRODFILI
                  SET IDPRODATIV = 'A'
                WHERE PRODFILI.CDPRODUTO = V_CDPRODCOMPRA
                  AND PRODFILI.CDFILIAL = C_REQUISICOES.CDFILIAL
                  AND PRODFILI.IDPRODATIV = 'I';
            ELSE
               INSERT INTO PRODFILI (CDFILIAL, CDPRODUTO, IDPRODATIV)
               VALUES(C_REQUISICOES.CDFILIAL, V_CDPRODCOMPRA, 'A');
            END IF;

            -- Quantidade do produto de compra que atende  demanda do produto de estoque
            V_QUANTIDADE := CEIL(C_PRODUTOS.QUANTIDADE/V_VRFATOCONV);

            V_VRARREDCMP := CASE WHEN NVL(V_VRARREDCMP, 0.00) = 0.00 THEN 1.0 ELSE V_VRARREDCMP END;

            -- Aplica o arredondamento de compras na quantidade
            V_QUANTIDADE := CEIL(V_QUANTIDADE/V_VRARREDCMP) * V_VRARREDCMP;

            --Data de entrega do produto : considera o limite de segurana do produto
            SELECT NVL(MAX(TO_NUMBER(L.NRLIMISEGU)),0)
              INTO V_NRLIMISEGU
              FROM LIMISEGPROD L
                   INNER JOIN PRODUTO P ON P.CDPRODUTO = L.CDPRODUTO
              WHERE L.CDFILIAL  = C_REQUISICOES.CDFILIAL
              AND P.CDARVPROD = (SELECT MAX(B.CDARVPROD)
                                   FROM LIMISEGPROD A, PRODUTO B
                                  WHERE (A.CDPRODUTO = B.CDPRODUTO)
                                    AND (A.CDFILIAL  = C_REQUISICOES.CDFILIAL)
                                    AND (INSTR(C_PRODUTOS.CDARVPROD,B.CDARVPROD) = 1));


            -- Marca do produto
            V_DTPRODUTO := CARREGA_PERIFILI_FUN(C_REQUISICOES.CDFILIAL, C_PRODUTOS.CDARVPROD, C_REQUISICOES.DTREQUIPEDIDO - V_NRLIMISEGU);
            SELECT
               MAX(PARASUPRI.CDMARCA)
            INTO
               V_CDMARCA
            FROM PARASUPRI, FILIAL F
            WHERE PARASUPRI.CDFILIAL = NVL(F.CDFILCENTCMP, F.CDFILIAL)
              AND F.CDFILIAL = C_REQUISICOES.CDFILIAL;
            IF V_CDMARCA IS NULL THEN
               SELECT
                  MIN(CDMARCA)
               INTO
                  V_CDMARCA
               FROM
                  MARCPRODCOMP
               WHERE CDPRMARCOMPL = V_CDPRODCOMPRA;
            END IF;

            ------------------------------------------------------------------------------------
            -- Inclui item do pedido
            ------------------------------------------------------------------------------------

            IF V_CDMARCA IS NOT NULL THEN
               INSERT INTO ITEMPEDEXOL
               (CDFILDEST, CDFILLANC, NRPEDEXOL, CDMARCA,
                CDPRODUTO, DTPROGENPEOL, QTPROGENPEOL,
                NRSEQLOGIMPOL, CDPRODORIGPEDOL, QTORIGPRODPED,
                DTPROGEMBARQ)
               VALUES
               (C_REQUISICOES.CDFILIAL, P_CDFILIPROC, V_NRPEDEXOL, V_CDMARCA,
                V_CDPRODCOMPRA, V_DTPRODUTO, V_QUANTIDADE,
                NULL, C_PRODUTOS.CDPRODUTO, C_PRODUTOS.QUANTIDADE,
                CALCULA_DATAEMBARQUE_OL(C_REQUISICOES.CDFILIOPELOG,
                                        C_REQUISICOES.CDFILIAL,
                                        V_CDARVPRODCOMPRA,
                                        V_DTPRODUTO)
                );

            ------------------------------------------------------------------------------------
            ------------------------------------------------------------------------------------
            END IF;
         END IF;
      END LOOP;
      -- Atualiza a REQUIPEDIDO com o pedido recm-criado, atualiza tambm o sequencial gerado
      UPDATE REQUIPEDIDO
         SET NRSEQREQUIPEDIDO = V_SEQREQUIPEDIDO,
             CDOPERULTATU = P_CDOPERADOR,
             DTULTATU = SYSDATE,
             NRPEDEXOL = V_NRPEDEXOL,
             CDFILDEST = C_REQUISICOES.CDFILIAL,
             CDFILLANC = P_CDFILIPROC
       WHERE ((CDFILIAL = C_REQUISICOES.CDFILIAL AND P_CDFILIALPADRAO IS NULL) OR ((P_CDFILIALPADRAO IS NOT NULL) AND INSTR(V_LISTAFILIAL, CDFILIAL)>0))
         AND ((CDSERVFILI = C_REQUISICOES.CDSERVFILI AND P_CDSERVPADRAO IS NULL) OR ((P_CDSERVPADRAO IS NOT NULL) AND INSTR(V_LISTASERV, CDSERVFILI)>0))
         AND DTREQUIPEDIDO = C_REQUISICOES.DTREQUIPEDIDO
         AND CDFILIOPELOG = C_REQUISICOES.CDFILIOPELOG
         AND CDGRUPPROD = C_REQUISICOES.CDGRUPPROD
         AND CDSUBGRPROD = C_REQUISICOES.CDSUBGRPROD
         AND (P_QUEBRATURNO <> 'S' OR
              (CDTURNO = C_REQUISICOES.CDTURNO))
         AND EXISTS (SELECT 1
                       FROM LISTA L
                      WHERE L.NRLISTA = P_NRLISTAREQUIPEDIDO
                        AND REQUIPEDIDO.NRREQUIPEDIDO = TO_NUMBER(L.CDLISTA));
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_PEDIDO_POR_REQUISICAO','5.85.xxx'); END;
/