<?php
namespace Zeedhi\DevOps\Model\Util;

use Zeedhi\Tools\DatabaseReader\Adapters\OracleSequenceNameProvider;
use Zeedhi\Tools\DatabaseReader\Exception;

class SequenceNameProvider extends OracleSequenceNameProvider{

    public function getSequenceName($tableName, $columnName)
    {
        if ($columnName != "ID") {
            throw Exception::sequenceDoesNotExist($tableName, $columnName);
        }
        if ($tableName == 'SUBRELEASE_PRODUCT_FILES') {
            $tableName = 'SUBRELEASE_PROD_FILES';
        } else if ($tableName == 'PRODUCT_VERSION_PACKAGES') {
            $tableName = 'PROD_VERSION_PACKAGES';
        } else if ($tableName == 'TASK_TYPE_COMMENT_TYPE_CLASSIF') {
            $tableName = 'T_TYPE_C_TYPE_CLASSIF';
        } else if ($tableName == 'TASK_TYPE_CLASSIFICATION') {
            $tableName = 'TASK_TYPE_CLASSIF';
        }

        return $tableName . "_ID_SEQ";
    }
} 